
local addon, ns = ...;
local L = setmetatable({},{__index=function(t,k) local v=tostring(k); rawset(t,k,v); return v; end});
ns.L = L;

-- Hi. This addon needs your help for localization. :)
-- https://wow.curseforge.com/projects/stayclassy/localization

-- english localization

L["Author"] = ""
L["CollectData"] = "Oops... Collecting data."
L["NoCandidates"] = "No candidates found..."
L["OptExpand"] = "Expand completed achievements"
L["OptHeadAOV"] = "Achievement overview"
L["OptHeadCCL"] = "Candidates check list"
L["OptHideKnown"] = "Hide members with known race"
L["OptMinimap"] = "Show minimap icon"
L["OptNoNotifications"] = "Currently there are no notifications collected..."
L["OptNotidyWrongDesc"] = "Print notification about wrong notes and/or officer notes in chat frame"
L["OptNotifyMsg"] = "Different races found: Over chat message = %s, in guild member %s = %s."
L["OptNotifyWrong"] = "Notify wrong notes"
L["OptRequire"] = "Show achievement requirements"
L["OptRTDesc"] = "This addon detecting the races of guild members through chat messages. Optionally, the races can also be recognized by reading the guild notes. For this, it is necessary to define the recognition characteristic manually."
L["OptScanNote"] = "Scan note"
L["OptScanOffNote"] = "Scan officer note"
L["OptShowCompleted"] = "Show completed criteria"
L["OptShowCount"] = "Show candidates counter"
L["OptShowUnknown"] = "Show candidates with unknown races"
L["OptTabMRT"] = "Manually race editing"
L["OptTabNotifications"] = "Notifications"
L["OptTabRT"] = "Race detection"
L["OptTabTT"] = "Tooltip options"
L["UnknownRaces"] = "Unknown races"

-- /end english localization

if LOCALE_deDE then
L["Author"] = "Autor"
L["CollectData"] = "Oops.. Sammle noch Daten."
L["NoCandidates"] = "Keine Kandidaten gefunden..."
L["OptExpand"] = "Erweiter abgeschlossene Erfolge"
L["OptHeadAOV"] = "Erfolgsübersicht"
L["OptHeadCCL"] = "Kandidatencheckliste"
L["OptHideKnown"] = "Verstecke Mitglieder mit bekannter Rasse"
L["OptMinimap"] = "Zeige Minikartensymbol"
L["OptNoNotifications"] = "Zur Zeit keine Benachrichtigungen gesammelt..."
L["OptNotidyWrongDesc"] = "Zeige Benachrichtigungen über falsche Notizen und/oder Offiziersnotizen im Chatfenster"
L["OptNotifyMsg"] = "Unterschiedliche Rassen gefunden: Über Chatnachricht = %s, in Gildenmitglied %s = %s"
L["OptNotifyWrong"] = "Melde falsche Notizen"
L["OptRequire"] = "Zeige Erfolgsanforderungen"
L["OptRTDesc"] = "Dieses Addon erkennt die Rassen von Gildenmitgliedern durch Chat-Nachrichten. Optional kann die Rassen auch durch lesen der Gildennotizen erkannt werden. Dazu ist es erforderlich, das Erkennungsmerkmal manuell zu definieren."
L["OptScanNote"] = "Scanne Notiz"
L["OptScanOffNote"] = "Scanne Offiziersnotiz"
L["OptShowCompleted"] = "Zeige abgeschlossene Kriterien"
L["OptShowCount"] = "Zeige Kandidatenzähler"
L["OptShowUnknown"] = "Zeige Kandidaten mit unbekannte Rassen"
L["OptTabMRT"] = "Rasse manuell bearbeiten"
L["OptTabNotifications"] = "Benachrichtigungen"
L["OptTabRT"] = "Rassenerkennung"
L["OptTabTT"] = "Tooltip Optionen"
L["UnknownRaces"] = "Unbekannte Rassen"

elseif LOCALE_esES then

elseif LOCALE_esMX then

elseif LOCALE_frFR then

elseif LOCALE_itIT then

elseif LOCALE_koKR then

elseif LOCALE_ptBR then

elseif LOCALE_ruRU then

elseif LOCALE_zhCN then

elseif LOCALE_zhTW then

end

-- races
if LOCALE_deDE then
	L.HUMAN = "Mensch"
	L.ORC = "Orc"
	L.DWARF = "Zwerg"
	L.NIGHTELF = "Nachtelf"
	L.SCOURGE = "Untoter"
	L.TAUREN = "Tauren"
	L.GNOME = "Gnom"
	L.TROLL = "Troll"
	L.GOBLIN = "Goblin"
	L.BLOODELF = "Blutelf"
	L.DRAENEI = "Draenei"
	L.WORGEN = "Worgen"
	L.PANDAREN = "Pandaren"
end

if LOCALE_enUS then
	L.HUMAN = "Human"
	L.ORC = "Orc"
	L.DWARF = "Dwarf"
	L.NIGHTELF = "Night Elf"
	L.SCOURGE = "Undead"
	L.TAUREN = "Tauren"
	L.GNOME = "Gnome"
	L.TROLL = "Troll"
	L.GOBLIN = "Goblin"
	L.BLOODELF = "Blood Elf"
	L.DRAENEI = "Draenei"
	L.WORGEN = "Worgen"
	L.PANDAREN = "Pandaren"
end

if LOCALE_esES then
	L.HUMAN = "Humano"
	L.ORC = "Orco"
	L.DWARF = "Enano"
	L.NIGHTELF = "Elfo de la noche"
	L.SCOURGE = "No-muerto"
	L.TAUREN = "Tauren"
	L.GNOME = "Gnomo"
	L.TROLL = "Trol"
	L.GOBLIN = "Goblin"
	L.BLOODELF = "Elfo de sangre"
	L.DRAENEI = "Draenei"
	L.WORGEN = "Huargen"
	L.PANDAREN = "Pandaren"
end

if LOCALE_esMX then
	L.HUMAN = "Humano"
	L.ORC = "Orco"
	L.DWARF = "Enano"
	L.NIGHTELF = "Elfo de la noche"
	L.SCOURGE = "No-muerto"
	L.TAUREN = "Tauren"
	L.GNOME = "Gnomo"
	L.TROLL = "Trol"
	L.GOBLIN = "Goblin"
	L.BLOODELF = "Elfo de sangre"
	L.DRAENEI = "Draenei"
	L.WORGEN = "Huargen"
	L.PANDAREN = "Pandaren"
end

if LOCALE_frFR then
	L.HUMAN = "Humain"
	L.ORC = "Orc"
	L.DWARF = "Nain"
	L.NIGHTELF = "Elfe de la nuit"
	L.SCOURGE = "Mort-vivant"
	L.TAUREN = "Tauren"
	L.GNOME = "Gnome"
	L.TROLL = "Troll"
	L.GOBLIN = "Gobelin"
	L.BLOODELF = "Elfe de sang"
	L.DRAENEI = "Draeneï"
	L.WORGEN = "Worgen"
	L.PANDAREN = "Pandaren"
end

if LOCALE_itIT then
	L.HUMAN = "Umano"
	L.ORC = "Orco"
	L.DWARF = "Nano"
	L.NIGHTELF = "Elfo della Notte"
	L.SCOURGE = "Non Morto"
	L.TAUREN = "Tauren"
	L.GNOME = "Gnomo"
	L.TROLL = "Troll"
	L.GOBLIN = "Goblin"
	L.BLOODELF = "Elfo del Sangue"
	L.DRAENEI = "Draenei"
	L.WORGEN = "Worgen"
	L.PANDAREN = "Pandaren"
end

if LOCALE_koKR then
	L.HUMAN = "인간"
	L.ORC = "오크"
	L.DWARF = "드워프"
	L.NIGHTELF = "나이트 엘프"
	L.SCOURGE = "언데드"
	L.TAUREN = "타우렌"
	L.GNOME = "노움"
	L.TROLL = "트롤"
	L.GOBLIN = "고블린"
	L.BLOODELF = "블러드 엘프"
	L.DRAENEI = "드레나이"
	L.WORGEN = "늑대인간"
	L.PANDAREN = "판다렌"
end

if LOCALE_ptBR then
	L.HUMAN = "Humano"
	L.ORC = "Orc"
	L.DWARF = "Anão"
	L.NIGHTELF = "Elfo Noturno"
	L.SCOURGE = "Morto-vivo"
	L.TAUREN = "Tauren"
	L.GNOME = "Gnomo"
	L.TROLL = "Troll"
	L.GOBLIN = "Goblin"
	L.BLOODELF = "Elfo Sangrento"
	L.DRAENEI = "Draenei"
	L.WORGEN = "Worgen"
	L.PANDAREN = "Pandaren"
end

if LOCALE_ruRU then
	L.HUMAN = "Человек"
	L.ORC = "Орк"
	L.DWARF = "Дворф"
	L.NIGHTELF = "Ночной эльф"
	L.SCOURGE = "Нежить"
	L.TAUREN = "Таурен"
	L.GNOME = "Гном"
	L.TROLL = "Тролль"
	L.GOBLIN = "Гоблин"
	L.BLOODELF = "Эльф крови"
	L.DRAENEI = "Дреней"
	L.WORGEN = "Ворген"
	L.PANDAREN = "Пандарен"
end

if LOCALE_zhCN then
	L.HUMAN = "人类"
	L.ORC = "兽人"
	L.DWARF = "矮人"
	L.NIGHTELF = "暗夜精灵"
	L.SCOURGE = "亡灵"
	L.TAUREN = "牛头人"
	L.GNOME = "侏儒"
	L.TROLL = "巨魔"
	L.GOBLIN = "地精"
	L.BLOODELF = "血精灵"
	L.DRAENEI = "德莱尼"
	L.WORGEN = "狼人"
	L.PANDAREN = "熊猫人"
end

if LOCALE_zhTW then
	L.HUMAN = "人類"
	L.ORC = "獸人"
	L.DWARF = "矮人"
	L.NIGHTELF = "夜精靈"
	L.SCOURGE = "不死族"
	L.TAUREN = "牛頭人"
	L.GNOME = "地精"
	L.TROLL = "食人妖"
	L.GOBLIN = "哥布林"
	L.BLOODELF = "血精靈"
	L.DRAENEI = "德萊尼"
	L.WORGEN = "狼人"
	L.PANDAREN = "熊貓人"
end


